//document responisble for controlling all user interaction through DOM manipulation
//of buttons

var colorPngs;
var allowDupes;
var allowBlanks;
var losses;
var guesses;
var wins;
var time;
var bestTime;
var showCopy;
var codeMaster;
var selector;
var timedGame;
var timedWins;
var dragColor = -1;
var dragSrc = null;
var isPrefChanged = false;

function setup(){
	//create buttons, glass and info
	new AppleGlassButton(document.getElementById("doneButton"), "Done", hidePrefs);
	new AppleGlassButton(document.getElementById("newGame"), "New Game", newGame);
 	new AppleGlassButton(document.getElementById("hideInstructions"), "Back", hideInstructions);
 	new AppleGlassButton(document.getElementById("clearStats"), "Clear Stats", clearStats);	
 	new AppleInfoButton(document.getElementById("infoButton"), document.getElementById("front"), "white", "white",showPrefs);
 	
	//add listeners
	document.addEventListener("keydown", keyHandler, true);
	if(window.widget){
		widget.onhide = hide;
	}
	
	//init static array
	colorPngs = [ "images/white.png", "images/blue.png", "images/black.png", "images/yellow.png", "images/red.png", "images/green.png" ];
	
	loadPrefs();
	
	selector = new ColorSelector();
	codeMaster = new CodeMaster();
	selector.selectColor(0);
	
	if(window.widget){
		var gameobj = eval(widget.preferenceForKey("save"));
	}
	if(gameobj){
		codeMaster.loadGame(gameobj);
	}else{
		codeMaster.newGame();
	}

}

function hide(){
	codeMaster.pause(true);
}

function newGame(){
	hidePrefs();
	codeMaster.newGame();
}

function prefsChanged(){
	isPrefChanged = true;
}

function keyHandler(e){
	e = (e) ? e : ((window.event) ? event : null);
	if(e){
		var code = (e.charCode) ? e.charCode : ((e.which) ? e.which : e.keyCode);
		keyHit = code - 49;
		if (keyHit < 6 && keyHit > -1) {
			selector.selectColor(keyHit);
		}
		e.stopPropagation();
		e.preventDefault();
	}
}

function clicked(url){
	if(window.widget)
		widget.openURL(url);
}

function formatTime(time){
	var mm = Math.floor(time/60) + "";
	var ss = time%60;
	if(ss < 10){
		ss = "0" + ss;
	}
	return mm + ":" + ss;
}

function toggleShowCopy(){
	showCopy = !showCopy;
}

function toggleShowTime(){
	timedGame = !timedGame;
	updateStats();
}
function donate(){
	clicked("https://www.paypal.com/cgi-bin/webscr?cmd=_xclick&business=backsmith%40gmail%2ecom&item_name=CodeBreaker%20widget&no_shipping=2&no_note=1&tax=0&currency_code=USD&lc=US&bn=PP%2dDonationsBF&charset=UTF%2d8");
}
