//defining objects
///////////////CODEMASTER/////////////////////
function CodeMaster(){
	//create game board
	this.gameOver = false;
	this.timer = new Timer(document.getElementById("timer"));;
	this.gameBoard = document.getElementById("gameBoard");
	this.play = document.getElementById("play");
	this.pauseButton = document.getElementById("pause");
	this.codeMaker = new CodeMaker(this.gameBoard);
	this.codeRows = [];
	
	var self = this;
	this.endGame = function(win){
		self.gameOver = true;
		self.okButton.setFunction(false);
		self.showPause(false);
		for(var i = 0; i < 10; i++){
			self.codeRows[i].repeat.enable(false);
		}
		self.codeMaker.reveal(true);
		self.timer.stop();
		clearSave();
		if(win){
			guesses += (10 - self.currentRow);
			wins++;
			if(timedGame){
				//handle timing
				var thisTime = self.timer.getSeconds();
				//if they got it right on the first guess then dont' count the stats
				if(thisTime != 0){
					timedWins++;
					time += thisTime;
					if(thisTime < bestTime || bestTime == 0){
						bestTime = thisTime;
					}
				}
			}
		}else{
			losses++;
		}
		saveStats();
		updateStats();
	}
	
	this.submitGuess = function(){
		if(self.currentRow == 9 && timedGame){
			self.timer.start();
			self.pauseButton.style.display = "block";
		}
		var row = self.codeRows[self.currentRow];
		if(self.codeMaker.evaluate(row.getGuess(), row.keyGroup)){
			self.endGame(true);
		}else{
			//disable current row
			self.codeRows[self.currentRow].setEnabled(false);
			self.codeRows[self.currentRow].repeat.enable(true);
		
			self.currentRow--;
			if(self.currentRow < 0){
				self.endGame(false);
			}else{
				self.okButton.setRow(self.currentRow);
				self.codeRows[self.currentRow].setEnabled(true);
			}
			saveGame();
		}
	}
	
	this.repeat = function(row){
		if(self.currentRow != 9){
			self.codeRows[self.currentRow].mock(self.codeRows[row]);
		}
	}
	
	this.showPause = function(show){
		self.pauseButton.style.display = show && !self.gameOver && timedGame && self.currentRow != 9 ? "block" : "none";
	}
	
	for(var i = 0; i < 10; i++){
		this.codeRows.push(new CodeRow(this.gameBoard, i, new RepeatButton(i, this.repeat)));
	}
	
	this.newGame = function(){
		self.timer.reset();
		self.gameOver = false;
		self.codeMaker.reveal(false);
		self.codeMaker.make(allowBlanks, allowDupes);
		self.okButton.setRow(9);
		self.okButton.setFunction(true);
		self.okButton.setVisible(true);
		self.showPause(false);
		for(var i = 0; i < 10; i++){
			self.codeRows[i].clear();
		}
		self.currentRow = 9;
		self.codeRows[self.currentRow].setEnabled(true);
		self.play.style.display = "none";
		self.timer.element.style.display = "block";
		clearSave();
	}
	this.play.onclick = function(){ self.pause(false) };
	this.pauseButton.onclick = function(){ self.pause(true) };
	this.okButton = new OKButton(this.submitGuess, this.newGame);
}

//Load the game with a game object.
//A game object has a timer value, a 2-dimenional set
//of arrays for pegs, and a secret code array
CodeMaster.prototype.loadGame = function(game){
	this.timer.reset();
	this.timer.setSeconds(game.time);
	this.gameOver = false;
	this.codeMaker.reveal(false);
	this.codeMaker.loadCode(game.code);
	this.currentRow = game.current;
	
	this.okButton.setRow(this.currentRow);
	this.okButton.setVisible(true);

	
	this.play.style.display = "none";
	this.showPause(true);
	this.timer.element.style.display = "block";
	
	for(var i = 0; i < 10 - this.currentRow; i++){
		this.codeRows[9 - i].setEnabled(true);
		for(var j = 0; j < 4; j++){
			this.codeRows[9 - i].pegGroup.pegs[j].setColor(game.guesses[i][j]);
		}
		if(9 - i != this.currentRow){
			this.codeMaker.evaluate(game.guesses[i], this.codeRows[9 - i].keyGroup);
			if(showCopy){
				this.codeRows[9 - i].repeat.enable(true);
			}
		}
	
		this.codeRows[9 - i].setEnabled(false);
	}
	this.codeRows[this.currentRow].setEnabled(true);
	this.pause(true);

}

CodeMaster.prototype.pause = function(pause){
	//conditions when not to pause
	if(this.currentRow == 9 || this.gameOver || !timedGame){
		return;
	}
	if(pause){
		this.timer.stop();
	}else{
		this.timer.start();
	}
	for(var i = this.currentRow; i < 10; i++){
		this.codeRows[i].pause(pause);
	}
	saveGame();
	
	this.okButton.setVisible(!pause);
	this.play.style.display = pause ? "block" : "none";
	//this.pauseButton.style.display = pause ? "none" : "block";
	this.showPause(!pause);
	this.timer.element.style.display = pause ? "none" : "block";
}

///////////////CODEMAKER/////////////////////
function CodeMaker(gameBoard){
	this.gameBoard = gameBoard;
	this.revealer = document.getElementById("revealerDiv");
	this.answerPegs = [];
	for(var i = 0; i < 4; i++){
		var next = document.createElement("img");
		next.style.position = "absolute";
		next.style.top = "4px";
		next.style.left = 56  + i*26 + "px";
		
		this.revealer.appendChild(next);
		this.answerPegs.push(next);
	}	
}

CodeMaker.prototype.make = function(blanks, dupes){
	this.code = [];
	for(var i = 0; i < 4; i++){
		var col;
		var validated;
		do{		
			validated = true;
			if(blanks){
				col = (Math.floor( Math.random()*(new Date()).getMilliseconds() ) % 7) - 1;
			}else{
				col = Math.floor(Math.random()*(new Date()).getMilliseconds()) % 6;
			}
			//if we do not allow dupes, make sure that this choice is not already made
			//if it is, we need to make a new selection
			if(!dupes){
				for(var j = 0; j < i; j++){
					if(this.code[j] == col){
						validated = false;
						break;
					}
				}
			}
		}while(!validated);
		this.code[i] = col;
	}
	this.loadImages();
}

CodeMaker.prototype.loadCode = function(code){
	this.code = code;
	this.loadImages();
}

CodeMaker.prototype.loadImages = function(){	
	//put the colors on
	for(var i = 0; i < 4; i++){
		this.answerPegs[i].src = this.code[i] == -1 ? "images/blank.png" : colorPngs[this.code[i]];
	}

}
CodeMaker.prototype.evaluate = function(guess, keyGroup){
	var numRed = 0;
	var numWhite = 0;
	var usedCode = [ false, false, false, false];
	var usedGuess = [ false, false, false, false];
	for(var i = 0; i < 4; i++){
		if(guess[i] == this.code[i]){
			numRed++;
			usedCode[i] = usedGuess[i] = true;
		}
	}
	
	for(var i = 0; i < 4; i++){	
		for(var j = 0; j < 4; j++){
			if(this.code[i] == guess[j] && !usedCode[i] && !usedGuess[j]){
				numWhite++;
				usedCode[i] = usedGuess[j] = true;
				break;
			}
		}
	}
	keyGroup.setKeys(numRed, numWhite);
	return numRed == 4;
}

CodeMaker.prototype.reveal = function(reveal){
	if(reveal){
		this.revealer.style.display = "block";
	}else{
		this.revealer.style.display = "none";
	}
}


///////////////OKButton/////////////////////
function OKButton(okAction, newAction){
	
	this.button = document.getElementById("okButton");
	this.button.src = "images/ok.png";
	
	this.okAction = okAction;
	this.newAction = newAction;
	this.setFunction(true);
	
	this.button.style.left = "152px";
}

OKButton.prototype.setRow = function(row){
	this.button.style.top = 52 + row*20 + "px";
}

//true for OK false for new game
OKButton.prototype.setFunction = function(ok){
	if(ok){
		this.button.src = "images/ok.png";
		this.button.onclick = this.okAction;
	}else{
		this.button.src = "images/new.png";
		this.button.onclick = this.newAction;
	}
}

OKButton.prototype.setVisible = function(visible){
	if(visible){
		this.button.style.display = "block";
	}else{
		this.button.style.display = "none";
	}
}

///////////////ColorSelector/////////////////////
function ColorSelector(){
	this.selected = null;
	this.selectors = [];

	this.highlight = document.createElement("img");
	this.highlight.src = "images/peg_hl.png";
	this.highlight.style.position = "absolute";
	this.highlight.style.top = "257px";
	this.highlight.style.display = "none";
	document.getElementById("front").appendChild(this.highlight);
	
	this.chosen = document.createElement("img");
	this.chosen.src = "images/peg_sel.png";
	this.chosen.style.position = "absolute";
	this.chosen.style.display = "none";
	this.chosen.style.top = "257px";
	
	document.getElementById("front").appendChild(this.chosen);
	
	var self = this;
	this.select = function(){
		for(var i = 0; i < 6; i++){
			if(self.selectors[i] == self.selected){
				ColorSelector.color = i;
				this.chosen.style.left = 38 + 21*i + "px";
				this.highlight.style.display = "none";
				this.chosen.style.display = "block";
			}
		}
	}

	for(var i = 0; i < 6; i++){
		var next = document.createElement("img");
		this.selectors.push(next);
		document.getElementById("front").appendChild(next);
		
		next.src = colorPngs[i];
		next.style.position = "absolute";
		next.style.top = "260px";
		next.style.left = 41 + 21*i + "px";
		next.setAttribute("class", "peg");
		next.hleft =  38 + 21*i + "px";
		next.color = i;
		next.onmouseover = function(){ 
			if(self.selected != this){
				self.highlight.style.display = "block";
				self.highlight.style.left =  this.hleft;
			}
		};
		
		next.onmouseout = function(){ 
			if(self.selected != this){
				self.highlight.style.display = "none";
			}
		};
		
		next.onclick = function(){
			self.selected = this;
			self.select();
		};
		
		//if we are paused do not allow dragging
		next.ondragstart = function(event){
			if(codeMaster.gameOver){
				return false;
			}
			dragColor = this.color;
			return true;
		}

	}
}

ColorSelector.prototype.selectColor  = function(index){
	this.selected = this.selectors[index];
	this.select();
}

ColorSelector.color = -1;

