function showPrefs(){
	codeMaster.pause(true);
	var front = document.getElementById("front");
	var back_w = document.getElementById("back");
	if (window.widget)
		widget.prepareForTransition("ToBack");
	front.style.display="none";
	back_w.style.display="block";

	if (window.widget)
		setTimeout('widget.performTransition();', 0);
}

function hidePrefs(){
	savePrefs();	
	if(isPrefChanged == true){
		codeMaster.newGame();
		isPrefChanged = false;
	}	

	var front = document.getElementById("front");
	var back_w = document.getElementById("back");
	if (window.widget){
		widget.prepareForTransition("ToFront");
	}
	back_w.style.display="none";
	front.style.display="block";
	if (window.widget){
		setTimeout ('widget.performTransition();', 0);
	}	
	
}

function savePrefs(){
	showCopy = (document.getElementById("showCopy").checked == 1);
	timedGame = (document.getElementById("allowTime").checked == 1);
	allowDupes = (document.getElementById("allowDupes").checked == 1);
	allowBlanks = (document.getElementById("allowBlanks").checked == 1);
	if(!timedGame && !codeMaster.gameOver){
		for(var i = 9; i > codeMaster.currentRow; i--){
			codeMaster.codeRows[i].repeat.enable(showCopy);
		}
	}
	widget.setPreferenceForKey(showCopy, "showCopy");
	widget.setPreferenceForKey(timedGame, "timedGame");
	widget.setPreferenceForKey(allowBlanks, "allowBlanks");
	widget.setPreferenceForKey(allowDupes, "allowDupes");
	
	saveGame();
}

function loadPrefs(){
	//load prefs
	if(window.widget){
		showCopy = widget.preferenceForKey("showCopy");
		timedGame = widget.preferenceForKey("timedGame");
		allowDupes = widget.preferenceForKey("allowDupes");
		allowBlanks = widget.preferenceForKey("allowBlanks");
		
		losses = widget.preferenceForKey("losses");	
		guesses = widget.preferenceForKey("guesses");
		wins = widget.preferenceForKey("wins");
		timedWins = widget.preferenceForKey("timedWins");
		time = widget.preferenceForKey("time");
		bestTime = widget.preferenceForKey("bestTime");
	}
	if(!showCopy){
		showCopy = false;
	}
	if(!timedGame){
		timedGame = false;
	}
	if(!allowDupes){
		allowDupes = false;
	}
	if(!allowBlanks){
		allowBlanks = false;
	}
	if(!losses){
		losses = 0;
	}
	if(!guesses){
		guesses = 0;
	}
	if(!wins){
		wins = 0;
	}
	if(!timedWins){
		timedWins = 0;
	}
	if(!time){
		time = 0;
	}
	if(!bestTime){
		bestTime = 0;
	}
	document.getElementById("showCopy").checked = showCopy;
	document.getElementById("allowTime").checked = timedGame;	
	document.getElementById("allowBlanks").checked = allowBlanks;
	document.getElementById("allowDupes").checked = allowDupes;
	
	updateStats();
}

function showInstructions(){
	document.getElementById("options").style.display = "none";
	document.getElementById("instructions").style.display = "block";
}

function hideInstructions(){
	document.getElementById("options").style.display = "block";
	document.getElementById("instructions").style.display = "none";
}

function updateStats(){
	//alert("time? " + time + " timedwins? " + timedWins);
	var percent = (wins + losses == 0 ? "N/A" : (Math.round( (wins/(losses + wins)*10000))/100) + "%");
	var average = (wins == 0 ? "N/A" :  Math.round(guesses*100/wins)/100);
	var averageTime = (timedWins == 0 || time == 0 ? "N/A" : formatTime(Math.round(time/timedWins)));
	var bestTimeString = (timedWins == 0 || bestTime == 0) ? "N/A" : formatTime(bestTime);
	document.getElementById("stats").innerHTML = 
										"<b>Statistics: " + 
										"<br/> Totals: " + wins + " wins " + losses + " losses" +
										"<br/> Percent games won: " + percent  + 
										"<br/> Average guesses to win: " + average + (
										timedGame ? (
											"<br/> Average time to win: " + averageTime + 
											"<br/> Best time: " + bestTimeString + "</b>"
										) : "");
}

function saveStats(){
	if(window.widget){
		widget.setPreferenceForKey(wins, "wins");
		widget.setPreferenceForKey(timedWins, "timedWins");
		widget.setPreferenceForKey(guesses, "guesses");
		widget.setPreferenceForKey(losses,"losses");
		widget.setPreferenceForKey(time, "time");
		widget.setPreferenceForKey(bestTime, "bestTime");
	}
}

function clearStats(){
	wins		= 0;
	timedWins	= 0;
	losses		= 0;
	guesses		= 0;
	time		= 0;
	bestTime	= 0;
	
	saveStats();
	updateStats();
}

