
function Timer(element){
	this.element = element;
	this.timer = null;
	this.seconds = 0;
	this.on = false;
	var self = this;
}

Timer.prototype.start = function(){
	this.on = true;
	var self = this;
	this.updateDisplay();
	this.timer = setTimeout(function() { self.tick(); }, 1000);
}

Timer.prototype.stop = function(){
	if(this.timer){
		clearTimeout(this.timer);
		this.timer = null;
	}
}

Timer.prototype.reset = function(){
	this.stop();
	this.seconds = 0;
	this.element.innerHTML = "";
}

Timer.prototype.updateDisplay = function(){
	this.element.innerHTML = formatTime(this.seconds);
}

Timer.prototype.tick = function(){
	if(this.on){
		this.seconds++;
		this.updateDisplay();
		var self = this
		this.timer = setTimeout(function() { self.tick(); }, 1000);
	}
}

Timer.prototype.getSeconds = function(){
	return this.seconds;
}

Timer.prototype.setSeconds = function(seconds){
	this.seconds = seconds
}


